#!/usr/bin/env slsh

require ("gtkdatabox");

variable databox, graph, i = 0, win, x, y, N = 1000;
variable x = Float_Type [N], y = Float_Type [N];
variable lissajous_counter = 0, lissajous_frequency = 3 * PI / 2;

define lissajous ()
{
   variable freq, k, off;
   
   lissajous_frequency += 0.001;
   off = lissajous_counter * 4 * PI / N;
   freq = 14 + 10 * sin (lissajous_frequency);
   _for k (0, N - 1, 1)
     {	
	x [k] = sin (k * 4 * PI / N + off);
	y [k] = cos (k * freq * PI / N + off);
     }   
   gtk_widget_queue_draw (databox);
   lissajous_counter ++;
   return TRUE;
}

win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
gtk_widget_set_size_request (win, 500, 500);
gtk_window_set_title (win, __argv [0]);
databox = gtk_databox_new ();
gtk_widget_modify_bg (databox, GTK_STATE_NORMAL, gdk_black);
graph = gtk_databox_grid_new (10, 10, gdk_grey, 0);
gtk_databox_graph_add (databox, graph);
graph = gtk_databox_lines_new (x, y, gdk_green, 2);
gtk_databox_graph_add (databox, graph);
gtk_databox_set_total_limits (databox, -1.1, 1.1, 1.1, -1.1);
gtk_container_add (win, databox);
() = g_signal_connect (win, "delete_event", &gtk_main_quit);
gtk_idle_add (&lissajous);
gtk_widget_show_all (win);
gtk_main ();
