#!/usr/bin/env slsh

require ("gtkdatabox");

variable databox, graph, win, x, y, table, ruler, scrollbar;

x = [-PI:PI:#1000];
y = sin (x);

win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
gtk_widget_set_size_request (win, 500, 500);
gtk_window_set_title (win, __argv [0]);

table = gtk_table_new (3, 3, 0);
gtk_container_add (win, table);

databox = gtk_databox_new ();
gtk_table_attach (table, databox, 0, 1, 0, 1,
		  GTK_FILL | GTK_EXPAND | GTK_SHRINK,
		  GTK_FILL | GTK_EXPAND | GTK_SHRINK, 0, 0);

graph = gtk_databox_lines_new (x, y, gdk_green, 0);

gtk_databox_graph_add (databox, graph);

ruler = gtk_databox_ruler_new (GTK_ORIENTATION_HORIZONTAL);
gtk_table_attach (table, ruler, 0, 1, 1, 2,
		  GTK_FILL | GTK_EXPAND | GTK_SHRINK, GTK_FILL, 0, 0);
gtk_databox_set_ruler_x (databox, ruler);

ruler = gtk_databox_ruler_new (GTK_ORIENTATION_VERTICAL);
gtk_table_attach (table, ruler, 1, 2, 0, 1,
		  GTK_FILL, GTK_FILL | GTK_EXPAND | GTK_SHRINK, 0, 0);
gtk_databox_set_ruler_y (databox, ruler);

scrollbar = gtk_hscrollbar_new (NULL);
gtk_table_attach (table, scrollbar, 0, 1, 2, 3,
		  GTK_FILL | GTK_EXPAND | GTK_SHRINK, GTK_FILL, 0, 0);
gtk_databox_set_adjustment_x (databox, gtk_range_get_adjustment (scrollbar));

scrollbar = gtk_vscrollbar_new (NULL);
gtk_table_attach (table, scrollbar, 2, 3, 0, 1,
		  GTK_FILL, GTK_FILL | GTK_EXPAND | GTK_SHRINK, 0, 0);
gtk_databox_set_adjustment_y (databox, gtk_range_get_adjustment (scrollbar));

gtk_databox_auto_rescale (databox, 0.05);

() = g_signal_connect (win, "delete_event", &gtk_main_quit);
gtk_widget_show_all (win);

gtk_main ();
