#!/usr/bin/env slsh

require ("gtkdatabox");

variable N = 5, box, databox, g, graph = GtkOpaque [N], win, x, y;
variable hbox, vbox, txt, buttons = GtkWidget [N], i, color = @gdk_red;

define add_remove (button, n)
{
   gtk_databox_graph_set_hide (graph [n], gtk_toggle_button_get_active (button));
   gtk_widget_queue_draw (databox);
}

x = [-PI:PI:PI/20];
y = sin (x);

win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
gtk_widget_set_size_request (win, 500, 500);
gtk_window_set_title (win, __argv [0]);
vbox = gtk_vbox_new (FALSE, 5);
gtk_container_add (win, vbox);
databox = gtk_databox_new ();
gtk_box_pack_start (vbox, databox, TRUE, TRUE, 0);
txt = gtk_label_new ("Press buttons to hide / show graphs.");
gtk_box_pack_start (vbox, txt, FALSE, FALSE, 0);
hbox = gtk_hbox_new (FALSE, 5);
gtk_box_pack_start (vbox, hbox, FALSE, FALSE, 0);

_for i (0, N - 1, 1)
{   
   color.red = 65535 * ((i + 1) mod 2);
   color.green = (65535 / 2) * ((i + 1) mod 3);
   color.blue = (65535 / 3) * ((i + 1) mod 4);
   graph [i] = gtk_databox_lines_new (x, (i + 1) * y, color, 0);
   gtk_databox_graph_add (databox, graph [i]);
   buttons [i] = gtk_toggle_button_new ();
   gtk_widget_modify_bg (buttons [i], GTK_STATE_NORMAL, color);
   gtk_box_pack_start (hbox, buttons [i], TRUE, TRUE, 0);
   () = g_signal_connect (buttons [i], "toggled", &add_remove, i);
}
gtk_databox_auto_rescale (databox, .05);

() = g_signal_connect (win, "delete_event", &gtk_main_quit);
gtk_widget_show_all (win);

gtk_main ();
